require "import"
import "android.widget.*"
import "android.view.View"
import "android.os.*"
import "android.content.*"
import "android.net.Uri"
import "android.app.AlertDialog"
import "android.graphics.Color"
import "android.text.Editable"
import "android.text.TextWatcher"

group_list = {
  {"accessible audio games", "https://chat.whatsapp.com/JL9JS70K5whDmMZ69DcdZI"},
  {"accessible text support", "https://chat.whatsapp.com/CFr3Ul1yfp2F8cFdyvLRe5"},
  {"Advance AI Oriented Training by NVS and NFB", "https://chat.whatsapp.com/JomS5lVxPWP5AoUMfGHBWg"},
  {"All Blinds of the World", "https://chat.whatsapp.com/ILtPX9sA9TrD7HpvDwtp8B"},
  {"All divyang news", "https://chat.whatsapp.com/HpcpcnYoDqn92jzKpHi8Au"},
  {"App Sharing Zone", "https://chat.whatsapp.com/FoDF2ecL2daDTwbquZoHz7"},
  {"Assignment helps du student only", "https://chat.whatsapp.com/F7CIORhfVYNGRVUjrWXa78"},
  {"Blind Gamers Community", "https://chat.whatsapp.com/JL9JS70K5whDmMZ69DcdZI"},
  {"Chatting lifestyle", "https://chat.whatsapp.com/BXN9tOgla7T5w3gIwUaXv2"},
  {"Divy Drishti", "https://chat.whatsapp.com/Fi9ieTvP1Vn3Dbn04zmA3Y"},
  {"Friend entertainment", "https://chat.whatsapp.com/LhoHom1RRpWDV2B68loioo"},
  {"General Group", "https://chat.whatsapp.com/HuUV3Y9tLHi3uhMm4SK7FY"},
  {"Hi genius", "https://chat.whatsapp.com/Bb5nHpmiNUjBUGlCWZJnQs"},
  {"India Sanatan Dharm Jay Shri Ram", "https://chat.whatsapp.com/G83OfxbAWYf9dcqWSQuW0P"},
  {"Independen blind group 2", "https://chat.whatsapp.com/BsTjncArXUpDC42Gt9XVZW"},
  {"Information Central Society", "https://chat.whatsapp.com/BqKq0znF4NMDSYXpk8cAmG"},
  {"Kns blind friends", "https://chat.whatsapp.com/Fihfu5piqSP82jW4Csp6xA"},
  {"KNS all India news", "https://chat.whatsapp.com/Cm4YyvWcU4F02cXgW6URe4"},
  {"KTM Official WhatsApp Group", "https://chat.whatsapp.com/KKQmqShxY6KHufRXz6asL6"},
  {"New Updates for V I Discussion Group", "https://chat.whatsapp.com/BSSMkocftGTKmZ9UzjvS2k"},
  {"Perfect Education", "https://chat.whatsapp.com/IcoBCTMavCNFNJKNKvyq0p"},
  {"Shayari aur Jokes ka Safar", "https://chat.whatsapp.com/H4VAHnVlaS81tPtElIuTWS"},
  {"Table-Ex Comunidad Española", "https://chat.whatsapp.com/JhTP2521v66EqYtWzX38sB"},
  {"Technology World for V I", "https://chat.whatsapp.com/IOmT9PvizP14cmOByWnW7q"},
  {"Technology help group", "https://chat.whatsapp.com/FJ5Oxhq60ca9WnVqveDYg6"},
  {"WhatsApp World", "https://chat.whatsapp.com/GAif6bUQp4OKR1AOQdtrrrU"},
  {"ऑल इंडिया हैंडीकैप दोस्त", "https://chat.whatsapp.com/DjaXmuVQ7wM9Kpap01NHRH"},
  {"🇮🇳 दिव्यांग संघ 2024.2025 🇮🇳", "https://chat.whatsapp.com/E3UmEpl5dC09wCD5bXC9Ix"},
  {"🇮🇳 राष्ट्रीय दिव्यांग एकता समूह", "https://chat.whatsapp.com/GFGoVM4QDWjDMMQVCUHnix"},
  {"नवयुग एकता मंच", "https://chat.whatsapp.com/FWIqynNReFTIEk2fuG1PzJ"},
  {"Android Knowledge for Blind Telegram Group", "https://t.me/tech_hup"},
  {"Join Our Telegram Channel", "https://t.me/+ibCyQTEm8KgzOTA1"},
  {"🛒ARAVALI ONLINE MARKET🛒", "https://chat.whatsapp.com/F0MbYLxA9NHBhvv1K0DNfV"},
  {"ज्ञान प्राप्ति का माध्यम", "https://chat.whatsapp.com/FvSYJRJPNl6EFIWd2wY8Gz"}
}

function sortGroups()
  table.sort(group_list, function(a, b)
    local aTelegram = a[2]:find("t.me")
    local bTelegram = b[2]:find("t.me")
    if aTelegram and not bTelegram then return false end
    if not aTelegram and bTelegram then return true end
    return a[1]:lower() < b[1]:lower()
  end)
end
sortGroups()

layout = {
  LinearLayout,
  id = "mainLayout",
  orientation = "vertical",
  padding = "10dp",
  {
    Button,
    id = "addNewBtn",
    text = "➕ Add New Group/Channel",
    layout_width = "match_parent"
  },
  {
    TextView,
    id = "welcomeText",
    text = "Welcome to VI Community 👋",
    textSize = "20sp",
    textColor = Color.GREEN,
    gravity = "center",
    layout_width = "match_parent"
  },
  {
    TextView,
    id = "devText",
    text = "Developed by Hersh Nagvanshi 🛠️",
    textSize = "16sp",
    textColor = Color.BLUE,
    gravity = "center",
    layout_width = "match_parent"
  },
  {
    Button,
    id = "themeToggle",
    text = "Switch to Dark Mode",
    layout_width = "match_parent"
  },
  {
    TextView,
    id = "timeText",
    text = "",
    textSize = "16sp",
    textColor = Color.BLACK,
    gravity = "center",
    layout_width = "match_parent"
  },
  {
    EditText,
    id = "searchBox",
    hint = "🔍 Search Groups...",
    layout_width = "match_parent",
    layout_height = "wrap_content"
  },
  {
    ListView,
    id = "list",
    layout_weight = 1
  },
  {
    Button,
    id = "exitButton",
    text = "🚪 Exit",
    layout_width = "match_parent"
  }
}

activity.setContentView(loadlayout(layout))

local handler = Handler()
function updateTime()
  local t = os.date("%A, %d %B %Y - %I:%M:%S %p")
  timeText.setText("🕒 " .. t)
  handler.postDelayed(updateTime, 1000)
end
updateTime()

function refreshList(filter)
  sortGroups()
  names = {}
  filtered_list = {}
  for i, v in ipairs(group_list) do
    local name = v[1]
    if not filter or name:lower():find(filter:lower()) then
      table.insert(filtered_list, v)
      table.insert(names, tostring(#names + 1) .. ". " .. name)
    end
  end
  adapter = ArrayAdapter(activity, android.R.layout.simple_list_item_1, String(names))
  list.setAdapter(adapter)
  current_list = filtered_list
end

refreshList()

searchBox.addTextChangedListener(TextWatcher {
  afterTextChanged = function(s)
    refreshList(tostring(s))
  end,
  beforeTextChanged = function() end,
  onTextChanged = function() end
})

list.setOnItemClickListener(AdapterView.OnItemClickListener {
  onItemClick = function(parent, view, position, id)
    local url = current_list[position + 1][2]
    local intent = Intent(Intent.ACTION_VIEW, Uri.parse(url))
    activity.startActivity(intent)
  end
})

list.setOnItemSelectedListener(AdapterView.OnItemSelectedListener {
  onItemSelected = function(parent, view, position, id)
    if view then view.setContentDescription(names[position + 1]) end
  end,
  onNothingSelected = function() end
})

exitButton.onClick = function()
  AlertDialog.Builder(activity)
    .setTitle("Exit Confirmation")
    .setMessage("Are you sure you want to exit?")
    .setPositiveButton("OK", {onClick=function() activity.finish() end})
    .setNegativeButton("Cancel", nil)
    .show()
end

isDark = false
themeToggle.onClick = function()
  if isDark then
    mainLayout.setBackgroundColor(0xFFFFFFFF)
    welcomeText.setTextColor(0xFF00FF00)
    devText.setTextColor(0xFF0000FF)
    timeText.setTextColor(0xFF000000)
    themeToggle.setText("Switch to Dark Mode")
    isDark = false
  else
    mainLayout.setBackgroundColor(0xFF000000)
    welcomeText.setTextColor(0xFFFFFF00)
    devText.setTextColor(0xFFFF00FF)
    timeText.setTextColor(0xFFFFFFFF)
    themeToggle.setText("Switch to Light Mode")
    isDark = true
  end
end

addNewBtn.onClick = function()
  local titleInput = EditText(activity)
  titleInput.setHint("Enter group or channel title")

  local urlInput = EditText(activity)
  urlInput.setHint("Enter WhatsApp or Telegram URL")

  local layoutInput = LinearLayout(activity)
  layoutInput.setOrientation(1)
  layoutInput.addView(titleInput)
  layoutInput.addView(urlInput)

  AlertDialog.Builder(activity)
    .setTitle("Add New Group/Channel")
    .setView(layoutInput)
    .setPositiveButton("Add", {
      onClick = function()
        local title = titleInput.getText().toString()
        local url = urlInput.getText().toString()
        if title ~= "" and url ~= "" then
          table.insert(group_list, {title, url})
          refreshList()
          Toast.makeText(activity, "✅ Added successfully!", Toast.LENGTH_SHORT).show()
        else
          Toast.makeText(activity, "⚠️ Title and URL are required!", Toast.LENGTH_SHORT).show()
        end
      end
    })
    .setNegativeButton("Cancel", nil)
    .show()
end